'''
Script to set the URL for a HTTP request
Ex:
/usr/bin/python3 /var/www/nebuleair_pro_4g/SARA/sara_setURL_uSpot_noSSL.py ttyAMA2 api-prod.uspot.probesys.net
To do: need to add profile id as parameter

First profile id:
    AT+UHTTP=0,1,"data.nebuleair.fr"
Second profile id:
    AT+UHTTP=1,1,"api-prod.uspot.probesys.net"
'''

import serial
import time
import sys
import json

parameter = sys.argv[1:]  # Exclude the script name
#print("Parameters received:")
port='/dev/'+parameter[0] # ex: ttyAMA2
url = parameter[1]  # ex: data.mobileair.fr


profile_id = 1


def read_complete_response(serial_connection, timeout=2, end_of_response_timeout=2):
    response = bytearray()
    serial_connection.timeout = timeout
    end_time = time.time() + end_of_response_timeout

    while True:
        if serial_connection.in_waiting > 0:
            data = serial_connection.read(serial_connection.in_waiting)
            response.extend(data)
            end_time = time.time() + end_of_response_timeout  # Reset timeout on new data
        elif time.time() > end_time:
            break
        time.sleep(0.1)  # Short sleep to prevent busy waiting

    return response.decode('utf-8', errors='replace')

baudrate = 115200

ser_sara = serial.Serial(
    port=port,  #USB0 or ttyS0
    baudrate=baudrate, #115200 ou 9600
    parity=serial.PARITY_NONE, #PARITY_NONE, PARITY_EVEN or PARITY_ODD
    stopbits=serial.STOPBITS_ONE,
    bytesize=serial.EIGHTBITS,
    timeout = 2
)



print("****")
print("SET URL (SARA)")

try:
       #step 1: set url (op_code = 1)
    print("****")
    print("SET URL")
    command = f'AT+UHTTP={profile_id},1,"{url}"\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_5 = read_complete_response(ser_sara)
    print(response_SARA_5)
    time.sleep(1)
    
    #step 2: set url to SSL (op_code = 6) (http_secure = 1 for HTTPS and 0 for HTTP)(USECMNG_PROFILE = 2)
    print("****")
    print("SET SSL")
    command = f'AT+UHTTP={profile_id},6,0\r'
    ser_sara.write(command.encode('utf-8'))
    response_SARA_5 = read_complete_response(ser_sara)
    print(response_SARA_5)
    time.sleep(1)

     #step 3: set PORT (op_code = 5)
    print("****")
    print("SET PORT")
    command = f'AT+UHTTP={profile_id},5,81\r'
    ser_sara.write((command + '\r').encode('utf-8'))
    response_SARA_55 = read_complete_response(ser_sara)
    print(response_SARA_55)
    time.sleep(1)

except serial.SerialException as e:
    print(f"Error: {e}")

finally:
    if ser_sara.is_open:
        ser_sara.close()
        print("****")
        #print("Serial closed")

